name: Unit Tests

on: [push,pull_request,workflow_dispatch]

jobs:
   build:
    runs-on: ubuntu-latest
    strategy:
      matrix:
        smalltalk: [ Pharo64-10, Pharo64-9.0, Pharo64-8.0 ]
    name: ${{ matrix.smalltalk }}
    steps:
      - name: Checkout
        uses: actions/checkout@v3
        with:
          fetch-depth: 2
      - uses: hpi-swa/setup-smalltalkCI@v1
        with:
          smalltalk-image: ${{ matrix.smalltalk }}
      - name: Load Image and Run Tests
        run: smalltalkci -s ${{ matrix.smalltalk }} .smalltalkci/.unit-tests.ston
        env:
          GITHUB_TOKEN: ${{ secrets.GITHUB_TOKEN }}
        timeout-minutes: 15
      - name: Run tests using Docker
        if: matrix.smalltalk == 'Pharo64-10'
        run: ./compose-test.sh
      - name: Upload coverage to Codecov
        uses: codecov/codecov-action@v1
        with:
          name: ${{matrix.os}}-${{matrix.smalltalk}}
          token: ${{ secrets.CODECOV_TOKEN }}
